import{s as bl,f as kt,n as _l,o as Ml}from"../chunks/scheduler.37c15a92.js";import{S as kl,i as Ll,g as l,s as m,r as St,m as r,H as c,A as Cl,h as i,f as a,c as p,j as u,u as Nt,n as o,B as h,x as g,k as d,y as n,a as e,v as At,d as Dt,t as Ft,w as Bt}from"../chunks/index.7cb9c9b8.js";import{H as Kt}from"../chunks/Heading.d3928e2a.js";function Tl(Ye){let $,aa,Qt,sa,A,ea,D,na,k,ve,la,qn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex"> \\theta </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',ia,Lt,Ze="maximize the expected return",ye,ma,F,tn="The idea is that we have a <em>parameterized stochastic policy</em>. In our case, a neural network outputs a probability distribution over actions. The probability of taking each action is also called the <em>action preference</em>.",pa,B,an="If we take the example of CartPole-v1:",ra,K,sn="<li>As input, we have a state.</li> <li>As output, we have a probability distribution over actions at that state.</li>",oa,Q,en,ca,V,nn=`Our goal with policy-gradient is to <strong>control the probability distribution of actions</strong> by tuning the policy such that <strong>good actions (that maximize the return) are sampled more frequently in the future.</strong>
Each time the agent interacts with the environment, we tweak the parameters such that good actions will be sampled more likely in the future.`,ha,X,ln="But <strong>how are we going to optimize the weights using the expected return</strong>?",ga,Y,mn=`The idea is that we’re going to <strong>let the agent interact during an episode</strong>. And if we win the episode, we consider that each action taken was good and must be more sampled in the future
since they lead to win.`,ua,E,xe,da,Sn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>P</mi><mo stretchy="false">(</mo><mi>a</mi><mi mathvariant="normal">∣</mi><mi>s</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">P(a|s)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.13889em;">P</span><span class="mopen">(</span><span class="mord mathnormal">a</span><span class="mord">∣</span><span class="mord mathnormal">s</span><span class="mclose">)</span></span></span></span>',fa,wa,Z,pn="The Policy-gradient algorithm (simplified) looks like this:",va,H,rn='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/pg_bigpicture.jpg" alt="Policy Gradient Big Picture"/>',ya,tt,on="Now that we got the big picture, let’s dive deeper into policy-gradient methods.",xa,at,ba,v,be,_a,Nn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>π</mi></mrow><annotation encoding="application/x-tex">\\pi</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">π</span></span></span></span>',Ma,ka,An='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',La,Ca,Dn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>π</mi></mrow><annotation encoding="application/x-tex">\\pi</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">π</span></span></span></span>',Ta,Ct,cn="outputs a probability distribution of actions",_e,Pa,R,hn='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/stochastic_policy.png" alt="Policy"/>',za,y,Me,$a,Fn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>π</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><msub><mi>a</mi><mi>t</mi></msub><mi mathvariant="normal">∣</mi><msub><mi>s</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">\\pi_\\theta(a_t|s_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord">∣</span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',ja,Ea,Bn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>a</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">a_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Ha,Ra,Kn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>s</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">s_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Ga,Ia,j,Tt,gn="But how do we know if our policy is good?",ke,Ja,Qn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Oa,Ua,st,Wa,et,un="The <em>objective function</em> gives us the <strong>performance of the agent</strong> given a trajectory (state action sequence without considering reward (contrary to an episode)), and it outputs the <em>expected cumulative reward</em>.",qa,nt,dn,Sa,lt,fn="Let’s give some more details on this formula:",Na,Pt,M,Le,zt,wn="expected return",Ce,Aa,Vn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>P</mi><mo stretchy="false">(</mo><mi>τ</mi><mo separator="true">;</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">P(\\tau;\\theta)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.13889em;">P</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mpunct">;</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Da,Fa,Xn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>R</mi><mo stretchy="false">(</mo><mi>τ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">R(\\tau)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mclose">)</span></span></span></span>',Ba,Ka,it,vn,Qa,G,Te,Va,Yn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>R</mi><mo stretchy="false">(</mo><mi>τ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">R(\\tau)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mclose">)</span></span></span></span>',Xa,Ya,x,Pe,Za,Zn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>P</mi><mo stretchy="false">(</mo><mi>τ</mi><mo separator="true">;</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">P(\\tau;\\theta)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.13889em;">P</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mpunct">;</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',ts,as,tl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>τ</mi></mrow><annotation encoding="application/x-tex">\\tau</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span></span></span></span>',ss,es,al='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',ns,ls,mt,yn,is,L,ze,ms,sl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',ps,rs,el='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',os,cs,I,$e,hs,nl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',gs,us,pt,xn,ds,rt,fs,f,je,ws,ll='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',vs,ys,il='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',xs,$t,bn="gradient-ascent",Ee,jt,_n="gradient-descent",He,bs,ml='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',_s,Ms,ot,Mn='(If you need a refresher on the difference between gradient descent and gradient ascent <a href="https://www.baeldung.com/cs/gradient-descent-vs-ascent" rel="nofollow">check this</a> and <a href="https://stats.stackexchange.com/questions/258721/gradient-ascent-vs-gradient-descent-in-logistic-regression" rel="nofollow">this</a>).',ks,ct,Re,Ls,pl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi><mo>←</mo><mi>θ</mi><mo>+</mo><mi>α</mi><mo>∗</mo><msub><mi mathvariant="normal">∇</mi><mi>θ</mi></msub><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\theta \\leftarrow \\theta + \\alpha *  \\nabla_\\theta J(\\theta) </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">←</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7778em;vertical-align:-0.0833em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.4653em;"></span><span class="mord mathnormal" style="margin-right:0.0037em;">α</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord">∇</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Cs,C,Ge,Ts,rl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',Ps,zs,ol='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',$s,js,J,Ie,Es,cl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Hs,Rs,ht,kn=`<li><p>We can’t calculate the true gradient of the objective function since it requires calculating the probability of each possible trajectory, which is computationally super expensive.
So we want to <strong>calculate a gradient estimation with a sample-based estimate (collect some trajectories)</strong>.</p></li> <li><p>We have another problem that I explain in the next optional section. To differentiate this objective function, we need to differentiate the state distribution, called the Markov Decision Process dynamics. This is attached to the environment. It gives us the probability of the environment going into the next state, given the current state and the action taken by the agent. The problem is that we can’t differentiate it because we might not know about it.</p></li>`,Gs,gt,Ln,Is,ut,Cn="Fortunately we’re going to use a solution called the Policy Gradient Theorem that will help us to reformulate the objective function into a differentiable function that does not involve the differentiation of the state distribution.",Js,dt,Tn,Os,ft,Pn="If you want to understand how we derive this formula for approximating the gradient, check out the next (optional) section.",Us,wt,Ws,T,Je,Et,zn="uses an estimated return from an entire episode to update the policy parameter",Oe,qs,hl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',Ss,Ns,vt,$n="In a loop:",As,P,Vt,O,Ue,Ds,gl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>π</mi><mi>θ</mi></msub></mrow><annotation encoding="application/x-tex">\\pi_\\theta</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Fs,Bs,ul='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>τ</mi></mrow><annotation encoding="application/x-tex">\\tau</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span></span></span></span>',We,yt,Ht,qe,Ks,dl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mover accent="true"><mi>g</mi><mo>^</mo></mover><mo>=</mo><msub><mi mathvariant="normal">∇</mi><mi>θ</mi></msub><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">\\hat{g} = \\nabla_\\theta J(\\theta)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8889em;vertical-align:-0.1944em;"></span><span class="mord accent"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.6944em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">g</span></span><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.2222em;"><span class="mord">^</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1944em;"><span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord">∇</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Se,xt,jn='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/policy_gradient_one.png" alt="Policy Gradient"/>',Ne,Xt,Rt,Ae,Qs,fl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi><mo>←</mo><mi>θ</mi><mo>+</mo><mi>α</mi><mover accent="true"><mi>g</mi><mo>^</mo></mover></mrow><annotation encoding="application/x-tex">\\theta \\leftarrow \\theta + \\alpha \\hat{g}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">←</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7778em;vertical-align:-0.0833em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8889em;vertical-align:-0.1944em;"></span><span class="mord mathnormal" style="margin-right:0.0037em;">α</span><span class="mord accent"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.6944em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">g</span></span><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.2222em;"><span class="mord">^</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1944em;"><span></span></span></span></span></span></span></span></span>',Vs,bt,En="We can interpret this update as follows:",Xs,w,De,Ys,wl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi mathvariant="normal">∇</mi><mi>θ</mi></msub><mi>l</mi><mi>o</mi><mi>g</mi><msub><mi>π</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><msub><mi>a</mi><mi>t</mi></msub><mi mathvariant="normal">∣</mi><msub><mi>s</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">\\nabla_\\theta log \\pi_\\theta(a_t|s_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord">∇</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="mord mathnormal">o</span><span class="mord mathnormal" style="margin-right:0.03588em;">g</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord">∣</span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Zs,Gt,Hn="steepest increase of the (log) probability",Fe,It,Rn="how we should change the weights of policy",Be,te,vl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>a</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">a_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ae,se,yl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>s</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">s_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ee,ne,U,Ke,le,xl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>R</mi><mo stretchy="false">(</mo><mi>τ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">R(\\tau)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mclose">)</span></span></span></span>',ie,me,_t,Gn="<li>If the return is high, it will <strong>push up the probabilities</strong> of the (state, action) combinations.</li> <li>Otherwise, if the return is low, it will <strong>push down the probabilities</strong> of the (state, action) combinations.</li>",pe,Mt,In="We can also <strong>collect multiple episodes (trajectories)</strong> to estimate the gradient:",re,W,Jn='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/policy_gradient_multiple.png" alt="Policy Gradient"/>',oe,Yt,ce;return A=new Kt({props:{title:"Diving deeper into policy-gradient methods",local:"diving-deeper-into-policy-gradient-methods",headingTag:"h1"}}),D=new Kt({props:{title:"Getting the big picture",local:"getting-the-big-picture",headingTag:"h2"}}),at=new Kt({props:{title:"Diving deeper into policy-gradient methods",local:"diving-deeper-into-policy-gradient-methods",headingTag:"h2"}}),st=new Kt({props:{title:"The objective function",local:"the-objective-function",headingTag:"h3"}}),rt=new Kt({props:{title:"Gradient Ascent and the Policy-gradient Theorem",local:"gradient-ascent-and-the-policy-gradient-theorem",headingTag:"h2"}}),wt=new Kt({props:{title:"The Reinforce algorithm (Monte Carlo Reinforce)",local:"the-reinforce-algorithm-monte-carlo-reinforce",headingTag:"h2"}}),{c(){$=l("meta"),aa=m(),Qt=l("p"),sa=m(),St(A.$$.fragment),ea=m(),St(D.$$.fragment),na=m(),k=l("p"),ve=r("We just learned that policy-gradient methods aim to find parameters "),la=new c(!1),ia=r(" that "),Lt=l("strong"),Lt.textContent=Ze,ye=r("."),ma=m(),F=l("p"),F.innerHTML=tn,pa=m(),B=l("p"),B.textContent=an,ra=m(),K=l("ul"),K.innerHTML=sn,oa=m(),Q=l("img"),ca=m(),V=l("p"),V.innerHTML=nn,ha=m(),X=l("p"),X.innerHTML=ln,ga=m(),Y=l("p"),Y.innerHTML=mn,ua=m(),E=l("p"),xe=r("So for each state-action pair, we want to increase the "),da=new c(!1),fa=r(": the probability of taking that action at that state. Or decrease if we lost."),wa=m(),Z=l("p"),Z.textContent=pn,va=m(),H=l("figure"),H.innerHTML=rn,ya=m(),tt=l("p"),tt.textContent=on,xa=m(),St(at.$$.fragment),ba=m(),v=l("p"),be=r("We have our stochastic policy "),_a=new c(!1),Ma=r(" which has a parameter "),ka=new c(!1),La=r(". This "),Ca=new c(!1),Ta=r(", given a state, "),Ct=l("strong"),Ct.textContent=cn,_e=r("."),Pa=m(),R=l("figure"),R.innerHTML=hn,za=m(),y=l("p"),Me=r("Where "),$a=new c(!1),ja=r(" is the probability of the agent selecting action "),Ea=new c(!1),Ha=r(" from state "),Ra=new c(!1),Ga=r(" given our policy."),Ia=m(),j=l("p"),Tt=l("strong"),Tt.textContent=gn,ke=r(" We need to have a way to measure it. To know that, we define a score/objective function called "),Ja=new c(!1),Oa=r("."),Ua=m(),St(st.$$.fragment),Wa=m(),et=l("p"),et.innerHTML=un,qa=m(),nt=l("img"),Sa=m(),lt=l("p"),lt.textContent=fn,Na=m(),Pt=l("ul"),M=l("li"),Le=r("The "),zt=l("em"),zt.textContent=wn,Ce=r(" (also called expected cumulative reward), is the weighted average (where the weights are given by "),Aa=new c(!1),Da=r(" of all possible values that the return "),Fa=new c(!1),Ba=r(" can take)."),Ka=m(),it=l("img"),Qa=m(),G=l("p"),Te=r("-"),Va=new c(!1),Xa=r(" :  Return from an arbitrary trajectory. To take this quantity and use it to calculate the expected return, we need to multiply it by the probability of each possible trajectory."),Ya=m(),x=l("p"),Pe=r("-"),Za=new c(!1),ts=r(" : Probability of each possible trajectory "),as=new c(!1),ss=r(" (that probability depends on "),es=new c(!1),ns=r(" since it defines the policy that it uses to select the actions of the trajectory which has an impact of the states visited)."),ls=m(),mt=l("img"),is=m(),L=l("p"),ze=r("-"),ms=new c(!1),ps=r(" : Expected return, we calculate it by summing for all trajectories, the probability of taking that trajectory given "),rs=new c(!1),os=r(" multiplied by the return of this trajectory."),cs=m(),I=l("p"),$e=r("Our objective then is to maximize the expected cumulative reward by finding the "),hs=new c(!1),gs=r(" that will output the best action probability distributions:"),us=m(),pt=l("img"),ds=m(),St(rt.$$.fragment),fs=m(),f=l("p"),je=r("Policy-gradient is an optimization problem: we want to find the values of "),ws=new c(!1),vs=r(" that maximize our objective function "),ys=new c(!1),xs=r(", so we need to use "),$t=l("strong"),$t.textContent=bn,Ee=r(". It’s the inverse of "),jt=l("em"),jt.textContent=_n,He=r(" since it gives the direction of the steepest increase of "),bs=new c(!1),_s=r("."),Ms=m(),ot=l("p"),ot.innerHTML=Mn,ks=m(),ct=l("p"),Re=r(`Our update step for gradient-ascent is:
`),Ls=new c(!1),Cs=m(),C=l("p"),Ge=r("We can repeatedly apply this update in the hopes that "),Ts=new c(!1),Ps=r(" converges to the value that maximizes "),zs=new c(!1),$s=r("."),js=m(),J=l("p"),Ie=r("However, there are two problems with computing the derivative of "),Es=new c(!1),Hs=r(":"),Rs=m(),ht=l("ol"),ht.innerHTML=kn,Gs=m(),gt=l("img"),Is=m(),ut=l("p"),ut.textContent=Cn,Js=m(),dt=l("img"),Os=m(),ft=l("p"),ft.textContent=Pn,Us=m(),St(wt.$$.fragment),Ws=m(),T=l("p"),Je=r("The Reinforce algorithm, also called Monte-Carlo policy-gradient, is a policy-gradient algorithm that "),Et=l("strong"),Et.textContent=zn,Oe=m(),qs=new c(!1),Ss=r(":"),Ns=m(),vt=l("p"),vt.textContent=$n,As=m(),P=l("ul"),Vt=l("li"),O=l("p"),Ue=r("Use the policy "),Ds=new c(!1),Fs=r("  to collect an episode "),Bs=new c(!1),We=m(),yt=l("li"),Ht=l("p"),qe=r("Use the episode to estimate the gradient "),Ks=new c(!1),Se=m(),xt=l("figure"),xt.innerHTML=jn,Ne=m(),Xt=l("li"),Rt=l("p"),Ae=r("Update the weights of the policy: "),Qs=new c(!1),Vs=m(),bt=l("p"),bt.textContent=En,Xs=m(),w=l("p"),De=r("-"),Ys=new c(!1),Zs=r(" is the direction of "),Gt=l("strong"),Gt.textContent=Hn,Fe=r(` of selecting action at from state st.
This tells us `),It=l("strong"),It.textContent=Rn,Be=r(" if we want to increase/decrease the log probability of selecting action "),te=new c(!1),ae=r(" at state "),se=new c(!1),ee=r("."),ne=m(),U=l("p"),Ke=r("-"),le=new c(!1),ie=r(": is the scoring function:"),me=m(),_t=l("ul"),_t.innerHTML=Gn,pe=m(),Mt=l("p"),Mt.innerHTML=In,re=m(),W=l("figure"),W.innerHTML=Jn,oe=m(),Yt=l("p"),this.h()},l(t){const s=Cl("svelte-u9bgzb",document.head);$=i(s,"META",{name:!0,content:!0}),s.forEach(a),aa=p(t),Qt=i(t,"P",{}),u(Qt).forEach(a),sa=p(t),Nt(A.$$.fragment,t),ea=p(t),Nt(D.$$.fragment,t),na=p(t),k=i(t,"P",{});var Jt=u(k);ve=o(Jt,"We just learned that policy-gradient methods aim to find parameters "),la=h(Jt,!1),ia=o(Jt," that "),Lt=i(Jt,"STRONG",{"data-svelte-h":!0}),g(Lt)!=="svelte-1vrdngf"&&(Lt.textContent=Ze),ye=o(Jt,"."),Jt.forEach(a),ma=p(t),F=i(t,"P",{"data-svelte-h":!0}),g(F)!=="svelte-1ocflgo"&&(F.innerHTML=tn),pa=p(t),B=i(t,"P",{"data-svelte-h":!0}),g(B)!=="svelte-okfb72"&&(B.textContent=an),ra=p(t),K=i(t,"UL",{"data-svelte-h":!0}),g(K)!=="svelte-bs6s8l"&&(K.innerHTML=sn),oa=p(t),Q=i(t,"IMG",{src:!0,alt:!0}),ca=p(t),V=i(t,"P",{"data-svelte-h":!0}),g(V)!=="svelte-1usf972"&&(V.innerHTML=nn),ha=p(t),X=i(t,"P",{"data-svelte-h":!0}),g(X)!=="svelte-y55wye"&&(X.innerHTML=ln),ga=p(t),Y=i(t,"P",{"data-svelte-h":!0}),g(Y)!=="svelte-1r32kyr"&&(Y.innerHTML=mn),ua=p(t),E=i(t,"P",{});var he=u(E);xe=o(he,"So for each state-action pair, we want to increase the "),da=h(he,!1),fa=o(he,": the probability of taking that action at that state. Or decrease if we lost."),he.forEach(a),wa=p(t),Z=i(t,"P",{"data-svelte-h":!0}),g(Z)!=="svelte-368gi1"&&(Z.textContent=pn),va=p(t),H=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),g(H)!=="svelte-r97oyl"&&(H.innerHTML=rn),ya=p(t),tt=i(t,"P",{"data-svelte-h":!0}),g(tt)!=="svelte-h48cfn"&&(tt.textContent=on),xa=p(t),Nt(at.$$.fragment,t),ba=p(t),v=i(t,"P",{});var z=u(v);be=o(z,"We have our stochastic policy "),_a=h(z,!1),Ma=o(z," which has a parameter "),ka=h(z,!1),La=o(z,". This "),Ca=h(z,!1),Ta=o(z,", given a state, "),Ct=i(z,"STRONG",{"data-svelte-h":!0}),g(Ct)!=="svelte-hu1hfg"&&(Ct.textContent=cn),_e=o(z,"."),z.forEach(a),Pa=p(t),R=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),g(R)!=="svelte-1l2lqzr"&&(R.innerHTML=hn),za=p(t),y=i(t,"P",{});var q=u(y);Me=o(q,"Where "),$a=h(q,!1),ja=o(q," is the probability of the agent selecting action "),Ea=h(q,!1),Ha=o(q," from state "),Ra=h(q,!1),Ga=o(q," given our policy."),q.forEach(a),Ia=p(t),j=i(t,"P",{});var Zt=u(j);Tt=i(Zt,"STRONG",{"data-svelte-h":!0}),g(Tt)!=="svelte-1i8sglg"&&(Tt.textContent=gn),ke=o(Zt," We need to have a way to measure it. To know that, we define a score/objective function called "),Ja=h(Zt,!1),Oa=o(Zt,"."),Zt.forEach(a),Ua=p(t),Nt(st.$$.fragment,t),Wa=p(t),et=i(t,"P",{"data-svelte-h":!0}),g(et)!=="svelte-1xlu0oc"&&(et.innerHTML=un),qa=p(t),nt=i(t,"IMG",{src:!0,alt:!0}),Sa=p(t),lt=i(t,"P",{"data-svelte-h":!0}),g(lt)!=="svelte-7h4zyq"&&(lt.textContent=fn),Na=p(t),Pt=i(t,"UL",{});var On=u(Pt);M=i(On,"LI",{});var S=u(M);Le=o(S,"The "),zt=i(S,"EM",{"data-svelte-h":!0}),g(zt)!=="svelte-zzl69g"&&(zt.textContent=wn),Ce=o(S," (also called expected cumulative reward), is the weighted average (where the weights are given by "),Aa=h(S,!1),Da=o(S," of all possible values that the return "),Fa=h(S,!1),Ba=o(S," can take)."),S.forEach(a),On.forEach(a),Ka=p(t),it=i(t,"IMG",{src:!0,alt:!0}),Qa=p(t),G=i(t,"P",{});var ge=u(G);Te=o(ge,"-"),Va=h(ge,!1),Xa=o(ge," :  Return from an arbitrary trajectory. To take this quantity and use it to calculate the expected return, we need to multiply it by the probability of each possible trajectory."),ge.forEach(a),Ya=p(t),x=i(t,"P",{});var N=u(x);Pe=o(N,"-"),Za=h(N,!1),ts=o(N," : Probability of each possible trajectory "),as=h(N,!1),ss=o(N," (that probability depends on "),es=h(N,!1),ns=o(N," since it defines the policy that it uses to select the actions of the trajectory which has an impact of the states visited)."),N.forEach(a),ls=p(t),mt=i(t,"IMG",{src:!0,alt:!0}),is=p(t),L=i(t,"P",{});var Ot=u(L);ze=o(Ot,"-"),ms=h(Ot,!1),ps=o(Ot," : Expected return, we calculate it by summing for all trajectories, the probability of taking that trajectory given "),rs=h(Ot,!1),os=o(Ot," multiplied by the return of this trajectory."),Ot.forEach(a),cs=p(t),I=i(t,"P",{});var ue=u(I);$e=o(ue,"Our objective then is to maximize the expected cumulative reward by finding the "),hs=h(ue,!1),gs=o(ue," that will output the best action probability distributions:"),ue.forEach(a),us=p(t),pt=i(t,"IMG",{src:!0,alt:!0}),ds=p(t),Nt(rt.$$.fragment,t),fs=p(t),f=i(t,"P",{});var b=u(f);je=o(b,"Policy-gradient is an optimization problem: we want to find the values of "),ws=h(b,!1),vs=o(b," that maximize our objective function "),ys=h(b,!1),xs=o(b,", so we need to use "),$t=i(b,"STRONG",{"data-svelte-h":!0}),g($t)!=="svelte-1m10mlp"&&($t.textContent=bn),Ee=o(b,". It’s the inverse of "),jt=i(b,"EM",{"data-svelte-h":!0}),g(jt)!=="svelte-1h262ip"&&(jt.textContent=_n),He=o(b," since it gives the direction of the steepest increase of "),bs=h(b,!1),_s=o(b,"."),b.forEach(a),Ms=p(t),ot=i(t,"P",{"data-svelte-h":!0}),g(ot)!=="svelte-tm5v0z"&&(ot.innerHTML=Mn),ks=p(t),ct=i(t,"P",{});var Qe=u(ct);Re=o(Qe,`Our update step for gradient-ascent is:
`),Ls=h(Qe,!1),Qe.forEach(a),Cs=p(t),C=i(t,"P",{});var Ut=u(C);Ge=o(Ut,"We can repeatedly apply this update in the hopes that "),Ts=h(Ut,!1),Ps=o(Ut," converges to the value that maximizes "),zs=h(Ut,!1),$s=o(Ut,"."),Ut.forEach(a),js=p(t),J=i(t,"P",{});var de=u(J);Ie=o(de,"However, there are two problems with computing the derivative of "),Es=h(de,!1),Hs=o(de,":"),de.forEach(a),Rs=p(t),ht=i(t,"OL",{"data-svelte-h":!0}),g(ht)!=="svelte-1ccvper"&&(ht.innerHTML=kn),Gs=p(t),gt=i(t,"IMG",{src:!0,alt:!0}),Is=p(t),ut=i(t,"P",{"data-svelte-h":!0}),g(ut)!=="svelte-mhy87w"&&(ut.textContent=Cn),Js=p(t),dt=i(t,"IMG",{src:!0,alt:!0}),Os=p(t),ft=i(t,"P",{"data-svelte-h":!0}),g(ft)!=="svelte-12htye5"&&(ft.textContent=Pn),Us=p(t),Nt(wt.$$.fragment,t),Ws=p(t),T=i(t,"P",{});var Wt=u(T);Je=o(Wt,"The Reinforce algorithm, also called Monte-Carlo policy-gradient, is a policy-gradient algorithm that "),Et=i(Wt,"STRONG",{"data-svelte-h":!0}),g(Et)!=="svelte-j30ps8"&&(Et.textContent=zn),Oe=p(Wt),qs=h(Wt,!1),Ss=o(Wt,":"),Wt.forEach(a),Ns=p(t),vt=i(t,"P",{"data-svelte-h":!0}),g(vt)!=="svelte-zhyuac"&&(vt.textContent=$n),As=p(t),P=i(t,"UL",{});var qt=u(P);Vt=i(qt,"LI",{});var Un=u(Vt);O=i(Un,"P",{});var ta=u(O);Ue=o(ta,"Use the policy "),Ds=h(ta,!1),Fs=o(ta,"  to collect an episode "),Bs=h(ta,!1),ta.forEach(a),Un.forEach(a),We=p(qt),yt=i(qt,"LI",{});var fe=u(yt);Ht=i(fe,"P",{});var Ve=u(Ht);qe=o(Ve,"Use the episode to estimate the gradient "),Ks=h(Ve,!1),Ve.forEach(a),Se=p(fe),xt=i(fe,"FIGURE",{class:!0,"data-svelte-h":!0}),g(xt)!=="svelte-1qgmq47"&&(xt.innerHTML=jn),fe.forEach(a),Ne=p(qt),Xt=i(qt,"LI",{});var Wn=u(Xt);Rt=i(Wn,"P",{});var Xe=u(Rt);Ae=o(Xe,"Update the weights of the policy: "),Qs=h(Xe,!1),Xe.forEach(a),Wn.forEach(a),qt.forEach(a),Vs=p(t),bt=i(t,"P",{"data-svelte-h":!0}),g(bt)!=="svelte-1ubiwhq"&&(bt.textContent=En),Xs=p(t),w=i(t,"P",{});var _=u(w);De=o(_,"-"),Ys=h(_,!1),Zs=o(_," is the direction of "),Gt=i(_,"STRONG",{"data-svelte-h":!0}),g(Gt)!=="svelte-1od0czd"&&(Gt.textContent=Hn),Fe=o(_,` of selecting action at from state st.
This tells us `),It=i(_,"STRONG",{"data-svelte-h":!0}),g(It)!=="svelte-v2e0ag"&&(It.textContent=Rn),Be=o(_," if we want to increase/decrease the log probability of selecting action "),te=h(_,!1),ae=o(_," at state "),se=h(_,!1),ee=o(_,"."),_.forEach(a),ne=p(t),U=i(t,"P",{});var we=u(U);Ke=o(we,"-"),le=h(we,!1),ie=o(we,": is the scoring function:"),we.forEach(a),me=p(t),_t=i(t,"UL",{"data-svelte-h":!0}),g(_t)!=="svelte-p5xd27"&&(_t.innerHTML=Gn),pe=p(t),Mt=i(t,"P",{"data-svelte-h":!0}),g(Mt)!=="svelte-22wa60"&&(Mt.innerHTML=In),re=p(t),W=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),g(W)!=="svelte-j15w63"&&(W.innerHTML=Jn),oe=p(t),Yt=i(t,"P",{}),u(Yt).forEach(a),this.h()},h(){d($,"name","hf:doc:metadata"),d($,"content",Pl),la.a=ia,kt(Q.src,en="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/policy_based.png")||d(Q,"src",en),d(Q,"alt","Policy based"),da.a=fa,d(H,"class","image table text-center m-0 w-full"),_a.a=Ma,ka.a=La,Ca.a=Ta,d(R,"class","image table text-center m-0 w-full"),$a.a=ja,Ea.a=Ha,Ra.a=Ga,Ja.a=Oa,kt(nt.src,dn="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/objective.jpg")||d(nt,"src",dn),d(nt,"alt","Return"),Aa.a=Da,Fa.a=Ba,kt(it.src,vn="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/expected_reward.png")||d(it,"src",vn),d(it,"alt","Return"),Va.a=Xa,Za.a=ts,as.a=ss,es.a=ns,kt(mt.src,yn="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/probability.png")||d(mt,"src",yn),d(mt,"alt","Probability"),ms.a=ps,rs.a=os,hs.a=gs,kt(pt.src,xn="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/max_objective.png")||d(pt,"src",xn),d(pt,"alt","Max objective"),ws.a=vs,ys.a=xs,bs.a=_s,Ls.a=null,Ts.a=Ps,zs.a=$s,Es.a=Hs,kt(gt.src,Ln="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/probability.png")||d(gt,"src",Ln),d(gt,"alt","Probability"),kt(dt.src,Tn="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/policy_gradient_theorem.png")||d(dt,"src",Tn),d(dt,"alt","Policy Gradient"),qs.a=Ss,Ds.a=Fs,Bs.a=null,Ks.a=null,d(xt,"class","image table text-center m-0 w-full"),Qs.a=null,Ys.a=Zs,te.a=ae,se.a=ee,le.a=ie,d(W,"class","image table text-center m-0 w-full")},m(t,s){n(document.head,$),e(t,aa,s),e(t,Qt,s),e(t,sa,s),At(A,t,s),e(t,ea,s),At(D,t,s),e(t,na,s),e(t,k,s),n(k,ve),la.m(qn,k),n(k,ia),n(k,Lt),n(k,ye),e(t,ma,s),e(t,F,s),e(t,pa,s),e(t,B,s),e(t,ra,s),e(t,K,s),e(t,oa,s),e(t,Q,s),e(t,ca,s),e(t,V,s),e(t,ha,s),e(t,X,s),e(t,ga,s),e(t,Y,s),e(t,ua,s),e(t,E,s),n(E,xe),da.m(Sn,E),n(E,fa),e(t,wa,s),e(t,Z,s),e(t,va,s),e(t,H,s),e(t,ya,s),e(t,tt,s),e(t,xa,s),At(at,t,s),e(t,ba,s),e(t,v,s),n(v,be),_a.m(Nn,v),n(v,Ma),ka.m(An,v),n(v,La),Ca.m(Dn,v),n(v,Ta),n(v,Ct),n(v,_e),e(t,Pa,s),e(t,R,s),e(t,za,s),e(t,y,s),n(y,Me),$a.m(Fn,y),n(y,ja),Ea.m(Bn,y),n(y,Ha),Ra.m(Kn,y),n(y,Ga),e(t,Ia,s),e(t,j,s),n(j,Tt),n(j,ke),Ja.m(Qn,j),n(j,Oa),e(t,Ua,s),At(st,t,s),e(t,Wa,s),e(t,et,s),e(t,qa,s),e(t,nt,s),e(t,Sa,s),e(t,lt,s),e(t,Na,s),e(t,Pt,s),n(Pt,M),n(M,Le),n(M,zt),n(M,Ce),Aa.m(Vn,M),n(M,Da),Fa.m(Xn,M),n(M,Ba),e(t,Ka,s),e(t,it,s),e(t,Qa,s),e(t,G,s),n(G,Te),Va.m(Yn,G),n(G,Xa),e(t,Ya,s),e(t,x,s),n(x,Pe),Za.m(Zn,x),n(x,ts),as.m(tl,x),n(x,ss),es.m(al,x),n(x,ns),e(t,ls,s),e(t,mt,s),e(t,is,s),e(t,L,s),n(L,ze),ms.m(sl,L),n(L,ps),rs.m(el,L),n(L,os),e(t,cs,s),e(t,I,s),n(I,$e),hs.m(nl,I),n(I,gs),e(t,us,s),e(t,pt,s),e(t,ds,s),At(rt,t,s),e(t,fs,s),e(t,f,s),n(f,je),ws.m(ll,f),n(f,vs),ys.m(il,f),n(f,xs),n(f,$t),n(f,Ee),n(f,jt),n(f,He),bs.m(ml,f),n(f,_s),e(t,Ms,s),e(t,ot,s),e(t,ks,s),e(t,ct,s),n(ct,Re),Ls.m(pl,ct),e(t,Cs,s),e(t,C,s),n(C,Ge),Ts.m(rl,C),n(C,Ps),zs.m(ol,C),n(C,$s),e(t,js,s),e(t,J,s),n(J,Ie),Es.m(cl,J),n(J,Hs),e(t,Rs,s),e(t,ht,s),e(t,Gs,s),e(t,gt,s),e(t,Is,s),e(t,ut,s),e(t,Js,s),e(t,dt,s),e(t,Os,s),e(t,ft,s),e(t,Us,s),At(wt,t,s),e(t,Ws,s),e(t,T,s),n(T,Je),n(T,Et),n(T,Oe),qs.m(hl,T),n(T,Ss),e(t,Ns,s),e(t,vt,s),e(t,As,s),e(t,P,s),n(P,Vt),n(Vt,O),n(O,Ue),Ds.m(gl,O),n(O,Fs),Bs.m(ul,O),n(P,We),n(P,yt),n(yt,Ht),n(Ht,qe),Ks.m(dl,Ht),n(yt,Se),n(yt,xt),n(P,Ne),n(P,Xt),n(Xt,Rt),n(Rt,Ae),Qs.m(fl,Rt),e(t,Vs,s),e(t,bt,s),e(t,Xs,s),e(t,w,s),n(w,De),Ys.m(wl,w),n(w,Zs),n(w,Gt),n(w,Fe),n(w,It),n(w,Be),te.m(vl,w),n(w,ae),se.m(yl,w),n(w,ee),e(t,ne,s),e(t,U,s),n(U,Ke),le.m(xl,U),n(U,ie),e(t,me,s),e(t,_t,s),e(t,pe,s),e(t,Mt,s),e(t,re,s),e(t,W,s),e(t,oe,s),e(t,Yt,s),ce=!0},p:_l,i(t){ce||(Dt(A.$$.fragment,t),Dt(D.$$.fragment,t),Dt(at.$$.fragment,t),Dt(st.$$.fragment,t),Dt(rt.$$.fragment,t),Dt(wt.$$.fragment,t),ce=!0)},o(t){Ft(A.$$.fragment,t),Ft(D.$$.fragment,t),Ft(at.$$.fragment,t),Ft(st.$$.fragment,t),Ft(rt.$$.fragment,t),Ft(wt.$$.fragment,t),ce=!1},d(t){t&&(a(aa),a(Qt),a(sa),a(ea),a(na),a(k),a(ma),a(F),a(pa),a(B),a(ra),a(K),a(oa),a(Q),a(ca),a(V),a(ha),a(X),a(ga),a(Y),a(ua),a(E),a(wa),a(Z),a(va),a(H),a(ya),a(tt),a(xa),a(ba),a(v),a(Pa),a(R),a(za),a(y),a(Ia),a(j),a(Ua),a(Wa),a(et),a(qa),a(nt),a(Sa),a(lt),a(Na),a(Pt),a(Ka),a(it),a(Qa),a(G),a(Ya),a(x),a(ls),a(mt),a(is),a(L),a(cs),a(I),a(us),a(pt),a(ds),a(fs),a(f),a(Ms),a(ot),a(ks),a(ct),a(Cs),a(C),a(js),a(J),a(Rs),a(ht),a(Gs),a(gt),a(Is),a(ut),a(Js),a(dt),a(Os),a(ft),a(Us),a(Ws),a(T),a(Ns),a(vt),a(As),a(P),a(Vs),a(bt),a(Xs),a(w),a(ne),a(U),a(me),a(_t),a(pe),a(Mt),a(re),a(W),a(oe),a(Yt)),a($),Bt(A,t),Bt(D,t),Bt(at,t),Bt(st,t),Bt(rt,t),Bt(wt,t)}}}const Pl='{"title":"Diving deeper into policy-gradient methods","local":"diving-deeper-into-policy-gradient-methods","sections":[{"title":"Getting the big picture","local":"getting-the-big-picture","sections":[],"depth":2},{"title":"Diving deeper into policy-gradient methods","local":"diving-deeper-into-policy-gradient-methods","sections":[{"title":"The objective function","local":"the-objective-function","sections":[],"depth":3}],"depth":2},{"title":"Gradient Ascent and the Policy-gradient Theorem","local":"gradient-ascent-and-the-policy-gradient-theorem","sections":[],"depth":2},{"title":"The Reinforce algorithm (Monte Carlo Reinforce)","local":"the-reinforce-algorithm-monte-carlo-reinforce","sections":[],"depth":2}],"depth":1}';function zl(Ye){return Ml(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Hl extends kl{constructor($){super(),Ll(this,$,zl,Tl,bl,{})}}export{Hl as component};
